<%--
%(C) COPYRIGHT International Business Machines Corp. 2013, All Rights Reserved
%US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%><%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8"
%><%@ page import="com.emptoris.framework.sso.UserRegistry"
%><%@ page import="com.rivermine.config.ApplicationProperties"
%><%@ page import="com.rivermine.config.property.system.SuiteApplicationDefinition"
%><%@ page import="com.rivermine.ui.servlet.RequestContext"
%><%@ page import="com.rivermine.util.StringUtil"
%><%!
public static Cookie getCookieByName(String cookieName, Cookie[] cookies)
{
    Cookie result = null;
    if (cookies != null)
    {
        for (Cookie cookie : cookies)
        {
            if (cookie.getName().equals(cookieName))
            {
                result = cookie;
                break;
            }
        }
    }
    return result;
}
public static void addCookie(HttpServletResponse response, String cookieName, String value, String path)
{
    Cookie cookie = new Cookie(cookieName, value);
    cookie.setPath(path);
    cookie.setHttpOnly(true);
    response.addCookie(cookie);
}
public static void removeCookie(HttpServletResponse response, Cookie cookie, String path)
{
    Cookie clone = new Cookie(cookie.getName(), "");
    clone.setHttpOnly(true);
    clone.setPath(path);
    clone.setMaxAge(0);
    response.addCookie(clone);
}
public static String getUrlForApplication(String targetApplication)
{
    StringBuilder path = new StringBuilder();
    path.append(SuiteApplicationDefinition.getBaseUrl(targetApplication));
    path.append("/sso_landing.jsp");
    return path.toString();
}
%><%
Cookie[] cookies = request.getCookies();
String contextPath = request.getContextPath();
String targetApp = request.getParameter("targetApp");
Cookie targetAppCookie = getCookieByName("targetApp", cookies);
if (StringUtil.isEmptyString(targetApp) && targetAppCookie != null)
{
    targetApp = targetAppCookie.getValue();
}
if (StringUtil.isEmptyString(targetApp))
{
    targetApp = "SSM";
}
addCookie(response, "targetApp", targetApp, contextPath);
String forwardUrl = null;
String landingApp = null;
if (request.getUserPrincipal() == null)
{
    forwardUrl = "/emptoris/login.jsp";
}
else
{
    String username = request.getUserPrincipal().getName();
    RequestContext.createInstance(getServletContext(), getServletName(), request);
    UserRegistry userRegistry = new UserRegistry();
    try
    {
        String accepttou = request.getParameter("accepttou");
        if ("n".equalsIgnoreCase(accepttou))
        {
            userRegistry.setTouAccepted(username, false);
            forwardUrl = "/emptoris/logout.jsp";
        }
        else
        {
            if ("y".equalsIgnoreCase(accepttou))
            {
                userRegistry.setTouAccepted(username, true);
                request.getSession().setAttribute("tou_action_performed", "true");
            }
            String redirectUrl = userRegistry.getPostLoginWorkflowRedirectUrl(username);
            if (redirectUrl != null)
            {
                forwardUrl = redirectUrl;
            }
            else
            {
                // add postLoginWorkflowComplete cookie with "/" as path
                addCookie(response, "postLoginWorkflowComplete", "true", "/");
                userRegistry.setPostLoginWorkflowComplete(username);
                landingApp = userRegistry.getLandingApplication(username);
            }
        }
    }
    catch (Exception e)
    {
        // GATE-3142 (LDAP - User validation does not happen on Emptoris side)
        forwardUrl = ApplicationProperties.getSSOErrorURLValue();
        // Remove TOU session attributes
        request.getSession().removeAttribute("tou_action_performed");
        request.getSession().removeAttribute("tou_prompted");
    }
    finally
    {
        userRegistry.disposeApplicationInstance();
        RequestContext.clearInstance();
    }
}
if (StringUtil.isEmptyString(forwardUrl))
{
    if (targetAppCookie != null)
    {
        removeCookie(response, targetAppCookie, contextPath);
    }
    if ("SSM".equals(targetApp))
    {
        String targetUrl = null;
        Cookie targetUrlCookie = getCookieByName("targetUrl", cookies);
        if (targetUrlCookie != null)
        {
            targetUrl = targetUrlCookie.getValue();
        }
        if (StringUtil.isEmptyString(targetUrl))
        {
            // go to landingApp when no deep-link is specified
            targetApp = landingApp;
        }
        if (landingApp == null)
        {
            landingApp = "NONE";
        }
        if ("PGM".equals(landingApp) || "VSM".equals(landingApp) || "NONE".equals(landingApp))
        {
            addCookie(response, "landingApp", landingApp, contextPath);
        }
    }
    // defaults to /emptoris/sso_landing.jsp
    forwardUrl = getUrlForApplication(targetApp);
}
//System.err.println(" POST_LOGIN ====================landingApp: " + landingApp);
//System.err.println(" POST_LOGIN ====================forwardUrl: " + forwardUrl);
%><!DOCTYPE HTML>
<HTML>
<HEAD>
<LINK rel="shortcut icon" type="image/icon" href="favicon.ico">
<META http-equiv="refresh" content="0; url=<%= forwardUrl %>">
</HEAD>
</HTML>
